diff --git a/src/include/storage/pg_shmem.h b/src/include/storage/pg_shmem.h
index 704b065f9e9..34b5e6c48ca 100644
--- a/src/include/storage/pg_shmem.h
+++ b/src/include/storage/pg_shmem.h
@@ -24,9 +24,11 @@
 #ifndef PG_SHMEM_H
 #define PG_SHMEM_H
 
+#include "port/atomics.h"
 #include "storage/barrier.h"
 #include "storage/dsm_impl.h"
 #include "storage/spin.h"
+#include "utils/guc.h"
 
 typedef struct AnonymousMapping
 {
@@ -73,14 +75,20 @@ extern PGDLLIMPORT AnonymousMapping Mappings[ANON_MAPPINGS];
 /*
  * ShmemControl is shared between backends and helps to coordinate shared
  * memory resize.
+ * 
+ * TODO: I think we need a lock to protect this structure. If we do so, do we
+ * need to use atomic integers?
  */
 typedef struct
 {
-	pg_atomic_uint32 	NSharedBuffers;
-	pid_t				evictor_pid;
-	Barrier 			Barrier;
-	pg_atomic_uint64 	Generation;
-	bool                Resizable;
+	pg_atomic_flag		resize_in_progress; /* true if resizing is in progress. false otherwise. */
+	pg_atomic_uint32	currentNBuffers; /* Original NBuffers value before resize started */
+	pg_atomic_uint32	targetNBuffers;
+	pg_atomic_uint32	activeNBuffers; /* Active portion of buffer pool during resizing. */
+	pg_atomic_uint32	transitNBuffers; /* Part of the buffer pool beyond activeNBuffers which may remain accessible during resizing. */
+	pid_t				coordinator;
+	ConditionVariable pm_cv; /* Coordinator waits for PM to complete its work using this CV. */
+	bool pmwork_done; /* PM has completed its work of resizing buffers. */
 } ShmemControl;
 
 extern PGDLLIMPORT ShmemControl *ShmemCtrl;
@@ -95,7 +103,8 @@ extern PGDLLIMPORT int shared_memory_type;
 extern PGDLLIMPORT int huge_pages;
 extern PGDLLIMPORT int huge_page_size;
 extern PGDLLIMPORT int huge_pages_status;
-extern PGDLLIMPORT int MaxAvailableMemory;
+extern PGDLLIMPORT bool finalMaxNBuffers;
+extern PGDLLIMPORT int MaxNBuffers;
 
 /* Possible values for huge_pages and huge_pages_status */
 typedef enum
@@ -145,7 +154,8 @@ extern void GetHugePageSize(Size *hugepagesize, int *mmap_flags,
 void PrepareHugePages(void);
 
 bool ProcessBarrierShmemResize(Barrier *barrier);
-void assign_shared_buffers(int newval, void *extra, bool *pending);
+const char *show_shared_buffers(void);
+bool check_shared_buffers(int *newval, void **extra, GucSource source);
 void AdjustShmemSize(void);
 extern void WaitOnShmemBarrier(void);
 extern void ShmemControlInit(void);
diff --git a/src/include/storage/procsignal.h b/src/include/storage/procsignal.h
index 97033f84dce..b80b05f2804 100644
--- a/src/include/storage/procsignal.h
+++ b/src/include/storage/procsignal.h
@@ -54,7 +54,10 @@ typedef enum
 typedef enum
 {
 	PROCSIGNAL_BARRIER_SMGRRELEASE, /* ask smgr to close files */
-	PROCSIGNAL_BARRIER_SHMEM_RESIZE, /* ask backends to resize shared memory */
+	PROCSIGNAL_BARRIER_SHBUF_SHRINK, /* shrink buffer pool - restrict allocations to new size */
+	PROCSIGNAL_BARRIER_SHBUF_RESIZE_MAP_AND_MEM, /* remap shared memory segments and update structure pointers */
+	PROCSIGNAL_BARRIER_SHBUF_EXPAND, /* expand buffer pool - enable allocations in new range */
+	PROCSIGNAL_BARRIER_SHBUF_RESIZE_FAILED, /* signal backends that the shared buffer resizing failed. */
 } ProcSignalBarrierType;
 
 /*
diff --git a/src/include/storage/shmem.h b/src/include/storage/shmem.h
index 64ff5a286ba..6944560d485 100644
--- a/src/include/storage/shmem.h
+++ b/src/include/storage/shmem.h
@@ -50,11 +50,19 @@ extern HTAB *ShmemInitHashInSegment(const char *name, long init_size,
 extern void *ShmemInitStruct(const char *name, Size size, bool *foundPtr);
 extern void *ShmemInitStructInSegment(const char *name, Size size,
 									  bool *foundPtr, int shmem_segment);
+extern void *ShmemUpdateStructInSegment(const char *name, Size size,
+										bool *foundPtr, int shmem_segment);
 extern Size add_size(Size s1, Size s2);
 extern Size mul_size(Size s1, Size s2);
 
 extern PGDLLIMPORT Size pg_get_shmem_pagesize(void);
 
+extern bool ProcessBarrierShmemShrink(void);
+extern bool ProcessBarrierShmemResizeMapAndMem(void);
+extern bool ProcessBarrierShmemExpand(void);
+extern bool ProcessBarrierShmemResizeFailed(void);
+
+
 /* ipci.c */
 extern void RequestAddinShmemSpace(Size size);
 
diff --git a/src/include/utils/guc.h b/src/include/utils/guc.h
index f21ec37da89..08a84373fb7 100644
--- a/src/include/utils/guc.h
+++ b/src/include/utils/guc.h
@@ -459,6 +459,8 @@ extern config_handle *get_config_handle(const char *name);
 extern void AlterSystemSetConfigFile(AlterSystemStmt *altersysstmt);
 extern char *GetConfigOptionByName(const char *name, const char **varname,
 								   bool missing_ok);
+extern void convert_int_from_base_unit(int64 base_value, int base_unit,
+									   int64 *value, const char **unit);
 
 extern void TransformGUCArray(ArrayType *array, List **names,
 							  List **values);
diff --git a/src/test/buffermgr/Makefile b/src/test/buffermgr/Makefile
index 97c3da9e20a..eb275027fa6 100644
--- a/src/test/buffermgr/Makefile
+++ b/src/test/buffermgr/Makefile
@@ -13,6 +13,9 @@ EXTRA_INSTALL = contrib/pg_buffercache
 
 REGRESS = buffer_resize
 
+# Custom configuration for buffer manager tests
+TEMP_CONFIG = $(srcdir)/buffermgr_test.conf
+
 subdir = src/test/buffermgr
 top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
diff --git a/src/test/buffermgr/buffermgr_test.conf b/src/test/buffermgr/buffermgr_test.conf
new file mode 100644
index 00000000000..21ccf66d9c7
--- /dev/null
+++ b/src/test/buffermgr/buffermgr_test.conf
@@ -0,0 +1,9 @@
+# Configuration for buffer manager regression tests
+
+# Even if max_shared_buffers is set multiple times only the last one is used to
+# as the limit on shared_buffers.
+max_shared_buffers = 128kB
+# Set initial shared_buffers as expected by test
+shared_buffers = 128MB
+# Set a larger value for max_shared_buffers to allow testing resize operations
+max_shared_buffers = 300MB 
\ No newline at end of file
diff --git a/src/test/buffermgr/meson.build b/src/test/buffermgr/meson.build
index e71dcdea685..561630e846f 100644
--- a/src/test/buffermgr/meson.build
+++ b/src/test/buffermgr/meson.build
@@ -8,10 +8,15 @@ tests += {
     'sql': [
       'buffer_resize',
     ],
+    'regress_args': ['--temp-config', files('buffermgr_test.conf')],
   },
   'tap': {
+    'env': {
+      'enable_injection_points': get_option('injection_points') ? 'yes' : 'no',
+    },
     'tests': [
       't/001_resize_buffer.pl',
+      't/003_parallel_resize_buffer.pl',
     ],
   },
 }
diff --git a/src/test/buffermgr/sql/buffer_resize.sql b/src/test/buffermgr/sql/buffer_resize.sql
index 45f5bb6d78b..dfaaeabfcbb 100644
--- a/src/test/buffermgr/sql/buffer_resize.sql
+++ b/src/test/buffermgr/sql/buffer_resize.sql
@@ -1,10 +1,8 @@
 -- Test buffer pool resizing and shared memory allocation tracking
 -- This test resizes the buffer pool multiple times and monitors
 -- shared memory allocations related to buffer management
-
--- Create a separate schema for this test
-CREATE SCHEMA buffer_resize_test;
-SET search_path TO buffer_resize_test, public;
+-- TODO: The test sets shared_buffers values in MBs. Instead it could use values
+-- in kBs so that the test runs on very small machines.
 
 -- Create a view for buffer-related shared memory allocations
 CREATE VIEW buffer_allocations AS
@@ -28,6 +26,13 @@ CREATE EXTENSION IF NOT EXISTS pg_buffercache;
 
 -- Test 1: Default shared_buffers 
 SHOW shared_buffers;
+SHOW max_shared_buffers;
+SELECT * FROM buffer_allocations;
+SELECT * FROM buffer_segments;
+SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
+-- Calling pg_resize_shared_buffers() without changing shared_buffers should be a no-op.
+SELECT pg_resize_shared_buffers();
+SHOW shared_buffers;
 SELECT * FROM buffer_allocations;
 SELECT * FROM buffer_segments;
 SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
@@ -35,7 +40,10 @@ SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
 -- Test 2: Set to 64MB  
 ALTER SYSTEM SET shared_buffers = '64MB';
 SELECT pg_reload_conf();
-SELECT pg_sleep(1);
+-- reconnect to ensure new setting is loaded
+\c
+SHOW shared_buffers;
+SELECT pg_resize_shared_buffers();
 SHOW shared_buffers;
 SELECT * FROM buffer_allocations;
 SELECT * FROM buffer_segments;
@@ -44,7 +52,10 @@ SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
 -- Test 3: Set to 256MB
 ALTER SYSTEM SET shared_buffers = '256MB';
 SELECT pg_reload_conf();
-SELECT pg_sleep(1);
+-- reconnect to ensure new setting is loaded
+\c
+SHOW shared_buffers;
+SELECT pg_resize_shared_buffers();
 SHOW shared_buffers;
 SELECT * FROM buffer_allocations;
 SELECT * FROM buffer_segments;
@@ -53,7 +64,10 @@ SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
 -- Test 4: Set to 100MB (non-power-of-two)
 ALTER SYSTEM SET shared_buffers = '100MB';
 SELECT pg_reload_conf();
-SELECT pg_sleep(1);
+-- reconnect to ensure new setting is loaded
+\c
+SHOW shared_buffers;
+SELECT pg_resize_shared_buffers();
 SHOW shared_buffers;
 SELECT * FROM buffer_allocations;
 SELECT * FROM buffer_segments;
@@ -62,12 +76,20 @@ SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
 -- Test 5: Set to minimum 128kB
 ALTER SYSTEM SET shared_buffers = '128kB';
 SELECT pg_reload_conf();
-SELECT pg_sleep(1);
+-- reconnect to ensure new setting is loaded
+\c
+SHOW shared_buffers;
+SELECT pg_resize_shared_buffers();
 SHOW shared_buffers;
 SELECT * FROM buffer_allocations;
 SELECT * FROM buffer_segments;
 SELECT COUNT(*) AS buffer_count FROM pg_buffercache;
 
--- Clean up the schema and all its objects
-RESET search_path;
-DROP SCHEMA buffer_resize_test CASCADE;
+-- Test 6: Try to set shared_buffers higher than max_shared_buffers (should fail)
+ALTER SYSTEM SET shared_buffers = '400MB';
+SELECT pg_reload_conf();
+-- reconnect to ensure new setting is loaded
+\c
+-- This should show the old value since the configuration was rejected
+SHOW shared_buffers;
+SHOW max_shared_buffers;
diff --git a/src/test/buffermgr/t/001_resize_buffer.pl b/src/test/buffermgr/t/001_resize_buffer.pl
index 8cf9e4539ab..7b0a78ebe5b 100644
--- a/src/test/buffermgr/t/001_resize_buffer.pl
+++ b/src/test/buffermgr/t/001_resize_buffer.pl
@@ -14,40 +14,26 @@ sub apply_and_verify_buffer_change
 {
 	my ($node, $new_size) = @_;
 	
-	# Use a single background_psql session for consistency
-	my $psql_session = $node->background_psql('postgres');
-	$psql_session->query_safe("ALTER SYSTEM SET shared_buffers = '$new_size'");
-	$psql_session->query_safe("SELECT pg_reload_conf()");
-	
-	# Wait till the resizing finishes using the same session
-	# 
-	# TODO: Right now there is no way to know when the resize has finished and
-	# all the backends are using new value of shared_buffers. Hence we poll
-	# manually until we get the expected value in the same session.
-	my $current_size;
-	my $attempts = 0;
-	my $max_attempts = 60; # 60 seconds timeout
-	do {
-		$current_size = $psql_session->query_safe("SHOW shared_buffers");
-		$attempts++;
-		
-		# Only sleep if we didn't get the expected result and haven't timed out yet
-		if ($current_size ne $new_size && $attempts < $max_attempts) {
-			sleep(1);
-		}
-	} while ($current_size ne $new_size && $attempts < $max_attempts);
-	
-	$psql_session->quit;
-	
-	# Check if we succeeded or timed out
-	if ($current_size ne $new_size) {
-		die "Timeout waiting for shared_buffers to change to $new_size (got $current_size after ${attempts}s)";
-	}
+	# Use the new pg_resize_shared_buffers() interface which handles everything synchronously
+	$node->safe_psql('postgres', "ALTER SYSTEM SET shared_buffers = '$new_size'");
+	$node->safe_psql('postgres', "SELECT pg_reload_conf()");
+	# Call the resize function - it returns when the operation is complete
+	is($node->safe_psql('postgres', "SELECT pg_resize_shared_buffers()"), 't',
+		'resizing to ' . $new_size . ' succeeded');
+	is($node->safe_psql('postgres', "SHOW shared_buffers"), $new_size,
+		'SHOW after resizing to '. $new_size . ' succeeded');
 }
 
 # Initialize a cluster and start pgbench in the background for concurrent load.
 my $node = PostgreSQL::Test::Cluster->new('main');
 $node->init;
+
+# Permit resizing up to 1GB for this test and let the server start with 128MB.
+$node->append_conf('postgresql.conf', qq{
+max_shared_buffers = 1GB
+shared_buffers = 128MB
+});
+
 $node->start;
 $node->safe_psql('postgres', "CREATE EXTENSION pg_buffercache");
 my $pgb_scale = 10;
diff --git a/src/test/buffermgr/t/003_parallel_resize_buffer.pl b/src/test/buffermgr/t/003_parallel_resize_buffer.pl
new file mode 100644
index 00000000000..9cbb5452fd2
--- /dev/null
+++ b/src/test/buffermgr/t/003_parallel_resize_buffer.pl
@@ -0,0 +1,71 @@
+# Copyright (c) 2025-2025, PostgreSQL Global Development Group
+#
+# Test that only one pg_resize_shared_buffers() call succeeds when multiple
+# sessions attempt to resize buffers concurrently
+
+use strict;
+use warnings;
+use IPC::Run;
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# Skip this test if injection points are not supported
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+# Initialize a cluster
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init;
+$node->append_conf('postgresql.conf', 'shared_preload_libraries = injection_points');
+$node->append_conf('postgresql.conf', 'shared_buffers = 128kB');
+$node->append_conf('postgresql.conf', 'max_shared_buffers = 256kB');
+$node->start;
+
+# Load injection points extension for test coordination
+$node->safe_psql('postgres', "CREATE EXTENSION injection_points");
+
+# Test 1: Two concurrent pg_resize_shared_buffers() calls
+# Set up injection point to pause the first resize call
+$node->safe_psql('postgres', 
+	"SELECT injection_points_attach('pg-resize-shared-buffers-flag-set', 'wait')");
+
+# Change shared_buffers for the resize operation
+$node->safe_psql('postgres', "ALTER SYSTEM SET shared_buffers = '144kB'");
+$node->safe_psql('postgres', "SELECT pg_reload_conf()");
+
+# Start first resize session (will pause at injection point)
+my $session1 = $node->background_psql('postgres');
+$session1->query_until(
+	qr/starting_resize/,
+	q(
+		\echo starting_resize
+		SELECT pg_resize_shared_buffers();
+	)
+);
+
+# Wait until session actually reaches the injection point
+$node->wait_for_event('client backend', 'pg-resize-shared-buffers-flag-set');
+
+# Start second resize session (should fail immediately since resize is in progress)
+my $result2 = $node->safe_psql('postgres', "SELECT pg_resize_shared_buffers()");
+
+# The second call should return false (already in progress)
+is($result2, 'f', 'Second concurrent resize call returns false');
+
+# Wake up the first session
+$node->safe_psql('postgres', 
+	"SELECT injection_points_wakeup('pg-resize-shared-buffers-flag-set')");
+
+# The pg_resize_shared_buffers() in session1 should now complete successfully
+# We can't easily capture the return value from query_until, but we can
+# verify the session completes without error and the resize actually happened
+$session1->quit;
+
+# Detach injection point
+$node->safe_psql('postgres', 
+	"SELECT injection_points_detach('pg-resize-shared-buffers-flag-set')");
+
+done_testing();
\ No newline at end of file
-- 
2.34.1

